18-四数之和
大约 3 分钟
题目地址(18. 四数之和 - 力扣(LeetCode))
https://leetcode.cn/problems/4sum/description/
题目描述
给你一个由 n
个整数组成的数组 nums
,和一个目标值 target
。请你找出并返回满足下述全部条件且不重复的四元组 [nums[a], nums[b], nums[c], nums[d]]
(若两个四元组元素一一对应,则认为两个四元组重复):
0 <= a, b, c, d < n
a
、b
、c
和d
互不相同nums[a] + nums[b] + nums[c] + nums[d] == target
你可以按 任意顺序 返回答案 。
示例 1:
输入:nums = [1,0,-1,0,-2,2], target = 0 输出:[[-2,-1,1,2],[-2,0,0,2],[-1,0,0,1]]
示例 2:
输入:nums = [2,2,2,2,2], target = 8 输出:[[2,2,2,2]]
提示:
1 <= nums.length <= 200
-109 <= nums[i] <= 109
-109 <= target <= 109
前置知识
- 哈希表
- 三数之和
思路
本题与「15. 三数之和」相似,解法也相似。
为了避免枚举到重复四元组,则需要保证每一重循环枚举到的元素不小于其上一重循环枚举到的元素,且在同一重循环中不能多次枚举到相同的元素。因此我们需要「排序」。
使用两重循环分别枚举前两个数,然后在两重循环枚举到的数之后使用双指针枚举剩下的两个数。
关键点
排序解决重复问题
使用两重循环分别枚举前两个数,然后在两重循环枚举到的数之后使用双指针枚举剩下的两个数。
代码
- 语言支持:Java
Java Code:
class Solution {
public List<List<Integer>> fourSum(int[] nums, int target) {
Arrays.sort(nums);
List<List<Integer>> ans = new ArrayList<>();
int n = nums.length;
// 枚举第一个数
for (int a = 0; a < n - 3; a++) {
long x = nums[a];
// 跳过重复数字
if (a > 0 && x == nums[a - 1]) continue;
if (x + nums[a + 1] + nums[a + 2] + nums[a + 3] > target) break;
if (x + nums[n - 3] + nums[n - 2] + nums[n - 1] < target) continue;
// 枚举第二个数
for (int b = a + 1; b < n - 2; b++) {
long y = nums[b];
if (b > a + 1 && y == nums[b - 1]) continue;
if (x + y + nums[b + 1] + nums[b + 2] > target) break;
if (x + y + nums[n - 2] + nums[n - 1] < target) continue;
int l = b + 1, r = n - 1;
while (l < r) {
long sum = x + y + nums[l] + nums[r];
if (sum > target) r--;
else if (sum < target) l++;
else {
// sum == target
ans.add(Arrays.asList((int)x, (int)y, nums[l], nums[r]));
l++;
while (l < r && nums[l] == nums[l - 1]) l++;
r--;
while (l < r && nums[r] == nums[r + 1]) r--;
}
}
}
}
return ans;
}
}
复杂度分析
令 n 为数组长度。
- 时间复杂度:,排序的时间复杂度是 ,枚举四元组的时间复杂度是 ,因此总时间复杂度为 。
- 空间复杂度:,空间复杂度主要取决于排序额外使用的空间。可以看成使用了一个额外的数组存储了数组 nums 的副本并排序,空间复杂度为 。